comment *

algorithm: 	MD4
size of digest:	128 bits (16 bytes)

 example:

 	push 	offset _buffer	; the addres of buffer to receive message digest (16 bytes)
	push	nSize		; the number of bytes of the data to be hashed
	push	offset _data	; the pointer of the data to be hashed
	call	MD4

	or:
	invoke	MD4, offset _data, nSize, offset _buffer

Tymon//tkm! <tymon_crk@wp.pl> www.tymon.crack.pl

important: use it at your own risk
*

MD4	PROTO	:DWORD, :DWORD, :DWORD

FF	macro 	_a,_b,_c,_d,k,s

	;	a = (a + F(b,c,d) + X[k]) <<< s
	;       F(b,c,d) = (b and c) or (not(b) and d)
	;	F(b,c,d) = (d xor (b and (c xor d)))	<- optimized

	mov	eax, _c
	xor	eax, _d
	and	eax, _b
	add	_a, k
	xor	eax, _d

	add	_a, eax
	rol	_a, s

endm

GG	macro 	_a,_b,_c,_d,k,s

	;	a = (a + G(b,c,d) + X[k] + 5A827999) <<< s
	;       G(b,c,d) = (b and c) or (b and d) or (c and d)
	;	G(b,c,d) = (c and d) or (b and (c xor d))   <- optimized

	mov	eax, _c
	mov	esi, _c
	and	eax, _d
	xor	esi, _d
	add	_a, k
	and	esi, _b
	or	eax, esi

	lea	_a, [_a+eax+05A827999h]
	rol	_a, s

endm

HH	macro 	_a,_b,_c,_d,k,s

	;	a = (a + H(b,c,d) + X[k] + 6ED9EBA1) <<< s.
	;	H(b,c,d) = b xor c xor d

	mov	eax, _b
	add	_a, k
	xor	eax, _c
	xor	eax, _d

	lea	_a, [_a+eax+6ED9EBA1h]
	rol	_a, s

endm

.data?

paddbuf		db	2*64 dup(?)
fpadd		dd	?
rounds		dd	?

.code

OPTION PROLOGUE: NONE
OPTION EPILOGUE: NONE

_64	dd	64
_8	dd	8

MD4 proc data:DWORD, l:DWORD, buffer:DWORD

	pushad

	mov	esi, [esp+24h]	; data
	mov	eax, [esp+28h]	; length
	xor	edx, edx
	add	esi, eax
	div	[_64]
	mov	rounds, eax

	sub	esi, edx
	mov	edi, offset paddbuf
	mov	ecx, edx
	rep movsb

	inc	ecx

	sub	edx, 56
	js	_2

	sub	edx, 64
	inc	ecx
_2:
	mov	fpadd, ecx

	inc	edx
	xor	eax, eax
	mov	byte ptr[edi], 80h
	xchg	edx, ecx
	inc	edi
	neg	ecx
	rep stosb

	xor	edx, edx
	mov	eax, [esp+28h]			; length
	mul	[_8]	
	
	mov	dword ptr[edi],   eax		; add length in bits
	mov	dword ptr[edi+4], edx

	mov	esi, [esp+2Ch]			; buffer

	mov	dword ptr[esi+0*4], 067452301h
	mov	dword ptr[esi+1*4], 0EFCDAB89h
	mov	dword ptr[esi+2*4], 098BADCFEh
	mov	dword ptr[esi+3*4], 010325476h

	mov	eax, rounds

	test	eax, eax
	jz	_padd

	mov	edi, [esp+24h]	; data

_next:
	push	esi				; save pointer

	mov	ebp, dword ptr[esi+0*4]
	mov	ebx, dword ptr[esi+1*4]
	mov	ecx, dword ptr[esi+2*4]
	mov	edx, dword ptr[esi+3*4]

;       /* Round 1. */

	FF	ebp,ebx,ecx,edx, dword ptr[edi+ 0*4], 3
	FF	edx,ebp,ebx,ecx, dword ptr[edi+ 1*4], 7
	FF	ecx,edx,ebp,ebx, dword ptr[edi+ 2*4], 11
	FF	ebx,ecx,edx,ebp, dword ptr[edi+ 3*4], 19
	FF	ebp,ebx,ecx,edx, dword ptr[edi+ 4*4], 3
	FF	edx,ebp,ebx,ecx, dword ptr[edi+ 5*4], 7
	FF	ecx,edx,ebp,ebx, dword ptr[edi+ 6*4], 11
	FF	ebx,ecx,edx,ebp, dword ptr[edi+ 7*4], 19
	FF	ebp,ebx,ecx,edx, dword ptr[edi+ 8*4], 3
	FF	edx,ebp,ebx,ecx, dword ptr[edi+ 9*4], 7
	FF	ecx,edx,ebp,ebx, dword ptr[edi+10*4], 11
	FF	ebx,ecx,edx,ebp, dword ptr[edi+11*4], 19
	FF	ebp,ebx,ecx,edx, dword ptr[edi+12*4], 3
	FF	edx,ebp,ebx,ecx, dword ptr[edi+13*4], 7
	FF	ecx,edx,ebp,ebx, dword ptr[edi+14*4], 11
	FF	ebx,ecx,edx,ebp, dword ptr[edi+15*4], 19

;       /* Round 2. */

	GG	ebp,ebx,ecx,edx, dword ptr[edi+ 0*4], 3
	GG	edx,ebp,ebx,ecx, dword ptr[edi+ 4*4], 5
	GG	ecx,edx,ebp,ebx, dword ptr[edi+ 8*4], 9
	GG	ebx,ecx,edx,ebp, dword ptr[edi+12*4], 13
	GG	ebp,ebx,ecx,edx, dword ptr[edi+ 1*4], 3
	GG	edx,ebp,ebx,ecx, dword ptr[edi+ 5*4], 5
	GG	ecx,edx,ebp,ebx, dword ptr[edi+ 9*4], 9
	GG	ebx,ecx,edx,ebp, dword ptr[edi+13*4], 13
	GG	ebp,ebx,ecx,edx, dword ptr[edi+ 2*4], 3
	GG	edx,ebp,ebx,ecx, dword ptr[edi+ 6*4], 5
	GG	ecx,edx,ebp,ebx, dword ptr[edi+10*4], 9
	GG	ebx,ecx,edx,ebp, dword ptr[edi+14*4], 13
	GG	ebp,ebx,ecx,edx, dword ptr[edi+ 3*4], 3
	GG	edx,ebp,ebx,ecx, dword ptr[edi+ 7*4], 5
	GG	ecx,edx,ebp,ebx, dword ptr[edi+11*4], 9
	GG	ebx,ecx,edx,ebp, dword ptr[edi+15*4], 13

;       /* Round 3. */

	HH	ebp,ebx,ecx,edx, dword ptr[edi+ 0*4], 3
	HH	edx,ebp,ebx,ecx, dword ptr[edi+ 8*4], 9
	HH	ecx,edx,ebp,ebx, dword ptr[edi+ 4*4], 11
	HH	ebx,ecx,edx,ebp, dword ptr[edi+12*4], 15
	HH	ebp,ebx,ecx,edx, dword ptr[edi+ 2*4], 3
	HH	edx,ebp,ebx,ecx, dword ptr[edi+10*4], 9
	HH	ecx,edx,ebp,ebx, dword ptr[edi+ 6*4], 11
	HH	ebx,ecx,edx,ebp, dword ptr[edi+14*4], 15
	HH	ebp,ebx,ecx,edx, dword ptr[edi+ 1*4], 3
	HH	edx,ebp,ebx,ecx, dword ptr[edi+ 9*4], 9
	HH	ecx,edx,ebp,ebx, dword ptr[edi+ 5*4], 11
	HH	ebx,ecx,edx,ebp, dword ptr[edi+13*4], 15
	HH	ebp,ebx,ecx,edx, dword ptr[edi+ 3*4], 3
	HH	edx,ebp,ebx,ecx, dword ptr[edi+11*4], 9
	HH	ecx,edx,ebp,ebx, dword ptr[edi+ 7*4], 11
	HH	ebx,ecx,edx,ebp, dword ptr[edi+15*4], 15

	pop	esi			; poiter to buffer

	add	dword ptr[esi+0*4], ebp
	add	dword ptr[esi+1*4], ebx
	add	dword ptr[esi+2*4], ecx
	add	dword ptr[esi+3*4], edx

	add	edi, 64			; next block

	dec	dword ptr[rounds]
	jnz	_next

_padd:

	mov	eax, fpadd
	test	eax, eax
	jz	_end
	xor	fpadd, eax
	mov	rounds, eax
	mov	edi, offset paddbuf
	jmp	_next
_end:

	popad
	ret	0Ch

MD4 endp

OPTION PROLOGUE: PROLOGUEDEF
OPTION EPILOGUE: EPILOGUEDEF